package com.cloudhopper.jni;

/*
 * #%L
 * ch-jni-loader
 * %%
 * Copyright (C) 2012 - 2013 Cloudhopper by Twitter
 * %%
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * #L%
 */

/**
 * Architecture
 * 
 * @author garth
 */
public enum Arch {
    x86,x86_64,sparc,unknown;
    
    public static Arch fromOsArch(String osArch) {
	osArch = osArch.toLowerCase();
	if (osArch.contains("amd64") || osArch.contains("x86_64")) return x86_64;
	if (osArch.contains("i386") || osArch.contains("x86")) return x86;
	if (osArch.contains("sparc")) return sparc;
	return unknown;
    }

    public static Arch getArch() {
	return fromOsArch(System.getProperty("os.arch"));
    }

    public static void main(String[] argv) {
	if (argv.length > 0) System.out.println(fromOsArch(argv[0]).name());
	else System.out.println(getArch().name());
    }

}
