package com.cloudhopper.jni;

/*
 * #%L
 * ch-jni-loader
 * %%
 * Copyright (C) 2012 - 2013 Cloudhopper by Twitter
 * %%
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * #L%
 */

/**
 * Operating system
 * 
 * @author garth
 */
public enum OS {
    windows("dll"),
    macosx("dylib"),
    linux("so"),
    solaris("so"),
    unknown(null);
    
    private final String suffix;
    
    OS(String suffix) {
	this.suffix = suffix;
    }
    
    public String getSuffix() { return this.suffix; }
    
    public static OS fromOsName(String osName) {
	osName = osName.toLowerCase();
	if (osName.contains("windows")) return windows;
	if (osName.contains("mac") || osName.contains("darwin")) return macosx;
	if (osName.contains("linux")) return linux;
	if (osName.contains("sun") || osName.contains("solaris")) return solaris;
	return unknown;
    }
    
    public static OS getOS() {
	return fromOsName(System.getProperty("os.name"));
    }

    public static void main(String[] argv) {
	if (argv.length > 0) System.out.println(fromOsName(argv[0]).name());
	else System.out.println(getOS().name());
    }

}
